blob: f97722d635c5b7a8c02cb0ddc45d31bd75f49483 [file] [log] [blame]
Philipp Maier7f340852018-07-10 16:21:54 +02001#!/bin/bash
2
3# Utility to verify the functionality of pysim-prog.py
4#
5# (C) 2018 by Sysmocom s.f.m.c. GmbH
6# All Rights Reserved
7#
8# Author: Philipp Maier
9#
10# This program is free software: you can redistribute it and/or modify
11# it under the terms of the GNU General Public License as published by
12# the Free Software Foundation, either version 2 of the License, or
13# (at your option) any later version.
14#
15# This program is distributed in the hope that it will be useful,
16# but WITHOUT ANY WARRANTY; without even the implied warranty of
17# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18# GNU General Public License for more details.
19#
20# You should have received a copy of the GNU General Public License
21# along with this program. If not, see <http://www.gnu.org/licenses/>.
22
23PYSIM_PROG=../pySim-prog.py
24PYSIM_READ=../pySim-read.py
25TEMPFILE=temp.tmp
26
27set -e
28
29echo "pysim-test - a test program to test pysim-prog.py"
30echo "================================================="
31
32# Generate a list of the cards we expect to see by checking which .ok files
33# are present
34function gen_card_list {
35 N_CARDS=0
36
37 echo "Expecting to see the following cards:"
38
39 for I in *.data ; do
40 CARD_NAMES[$N_CARDS]=${I%.*}
41 CARD_SEEN[$N_CARDS]=0
42 N_CARDS=$((N_CARDS+1))
43 done
44
45 for I in $(seq 0 $((N_CARDS-1))); do
46 echo ${CARD_NAMES[$I]}
47 done
48}
49
50# Increment counter in card list for a specified card name (type)
51function inc_card_list {
52 CARD_NAME=$1
53 for I in $(seq 0 $((N_CARDS-1))); do
54 if [ $CARD_NAME = ${CARD_NAMES[$I]} ]; then
55 CARD_SEEN[$I]=$((${CARD_NAMES[$I]}+1))
56 fi
57 done
58}
59
60# Check the card list, each card must be seen exactly one times
61function check_card_list {
62 for I in $(seq 0 $((N_CARDS-1))); do
63 if [ ${CARD_SEEN[$I]} -ne 1 ]; then
64 echo "Error: Card ${CARD_NAMES[$I]} seen ${CARD_SEEN[$I]} times!"
65 exit 1
66 fi
67 done
68
69 echo "All cards seen -- everything ok!"
70}
71
72# Verify the contents of a card by reading them and then diffing against the
73# previously created .ok file
74function check_card {
75 TERMINAL=$1
76 CARD_NAME=$2
77 echo "Verifying card ..."
78 stat ./$CARD_NAME.ok > /dev/null
79 python $PYSIM_READ -p $TERMINAL > $TEMPFILE
80 set +e
81 CARD_DIFF=$(diff $TEMPFILE ./$CARD_NAME.ok)
82 set -e
83
84 if [ "$CARD_DIFF" != "" ]; then
85 echo "Card contents do not match the test data:"
86 echo "Expected: $CARD_NAME.ok"
87 echo "------------8<------------"
88 cat "$CARD_NAME.ok"
89 echo "------------8<------------"
90 echo "Got:"
91 echo "------------8<------------"
92 cat $TEMPFILE
93 echo "------------8<------------"
94 exit 1
95 fi
96
97 inc_card_list $CARD_NAME
98
99 echo "Card contents match the test data -- success!"
100 rm $TEMPFILE
101}
102
103# Read out the card using pysim-read and store the result as .ok file. This
104# data will be used later in order to verify the results of our write tests.
105function gen_ok_file {
106 TERMINAL=$1
107 CARD_NAME=$2
108 python $PYSIM_READ -p $TERMINAL > "$CARD_NAME.ok"
109 echo "Generated file: $CARD_NAME.ok"
110 echo "------------8<------------"
111 cat "$CARD_NAME.ok"
112 echo "------------8<------------"
113}
114
115# Find out the type (card name) of the card that is installed in the specified
116# reader
117function probe_card {
118 TERMINAL=$1
119 RESULT=$(timeout 5 $PYSIM_PROG -p $TERMINAL -T | cut -d ":" -f 2 | tail -n 1 | xargs)
120 echo $RESULT
121}
122
123# Read out all cards and store the results as .ok files
124function gen_ok_files {
125 echo "== OK FILE GENERATION =="
126 for I in $(seq 0 $((N_TERMINALS-1))); do
127 echo "Probing card in terminal #$I"
128 CARD_NAME=$(probe_card $I)
129 if [ -z "$CARD_NAME" ]; then
130 echo "Error: Unresponsive card!"
131 exit 1
132 fi
133 echo "Card is of type: $CARD_NAME"
134 gen_ok_file $I $CARD_NAME
135 done
136}
137
138# Execute tests. Each card is programmed and the contents are checked
139# afterwards.
140function run_test {
141 for I in $(seq 0 $((N_TERMINALS-1))); do
142 echo "== EXECUTING TEST =="
143 echo "Probing card in terminal #$I"
144 CARD_NAME=$(probe_card $I)
145 if [ -z "$CARD_NAME" ]; then
146 echo "Error: Unresponsive card!"
147 exit 1
148 fi
149 echo "Card is of type: $CARD_NAME"
150
151 # Make sure some default data is set
152 MCC=001
153 MNC=01
154 ICCID=1122334455667788990
155 KI=FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
156 OPC=FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
157 IMSI=001010000000001
158 ADM=00000000
Daniel Willmannf432b2b2018-06-15 07:31:50 +0200159 ADM_OPT="-a"
Philipp Maier7f340852018-07-10 16:21:54 +0200160
Daniel Willmannf432b2b2018-06-15 07:31:50 +0200161 source "$CARD_NAME.data"
162 if [ -n "$ADM_HEX" ]; then
163 ADM_OPT="-A"
164 ADM=$ADM_HEX
165 fi
166 python $PYSIM_PROG -p $I -t $CARD_NAME -o $OPC -k $KI -x $MCC -y $MNC -i $IMSI -s $ICCID $ADM_OPT $ADM
Philipp Maier7f340852018-07-10 16:21:54 +0200167 check_card $I $CARD_NAME
168 echo ""
169 done
170}
171
172function usage {
173 echo "Options:"
174 echo "-n: number of card terminals"
175 echo "-o: generate .ok files"
176}
177
178# Make sure that the pathes to the python scripts always work, regardless from
179# where the script is called.
180CURDIR=$PWD
181SCRIPTDIR=$(dirname $0)
182cd $SCRIPTDIR
183PYSIM_PROG=$(realpath $PYSIM_PROG)
184PYSIM_READ=$(realpath $PYSIM_READ)
185cd $CURDIR
186
187OPT_N_TERMINALS=0
188OPT_GEN_OK_FILES=0
189while getopts ":hon:" OPT; do
190 case $OPT in
191 h)
192 usage
193 exit 0
194 ;;
195 o)
196 OPT_GEN_OK_FILES=1
197 ;;
198 n)
199 OPT_N_TERMINALS=$OPTARG
200 ;;
201 \?)
202 echo "Invalid option: -$OPTARG" >&2
203 exit 1
204 ;;
205 esac
206done
207
208N_TERMINALS=$OPT_N_TERMINALS
209
210# Generate a list of available cards, if no explicit reader number is given
211# then the number of cards will be used as reader number.
212gen_card_list
213if [ $N_TERMINALS -eq 0 ]; then
214 N_TERMINALS=$N_CARDS
215fi
216echo "Number of card terminals installed: $N_TERMINALS"
217echo ""
218
219if [ $OPT_GEN_OK_FILES -eq 1 ]; then
220 gen_ok_files
221 exit 0
222else
223 run_test
224 check_card_list
225 exit 0
226fi